package org.holdfast;


import java.io.*;
import java.util.Hashtable;
import java.util.Vector;

public class TextUtils {

    public static int ARRAY_LENGTH;
    private static String[] array;
    private static String[] a = null;

    public static String toLowerCase(String text) {
        text = text.toLowerCase();

        text = toLowerCase2(text);
        char[] chars = text.toCharArray();
        for (int i = 0; i < chars.length; i++) {
            if (chars[i] >= 0x410 && chars[i] < 0x430) {
                chars[i] += 0x20; // russian
            }            //else if(chars[i] >= 0x400 && chars[i] < 0x410) chars[i] += 0x50; // ukrainian, belarussian, macedonian, etc
            //else if(chars[i] > 0x40 && chars[i] < 0x5B) chars[i] += 0x20; // english
        }
        return new String(chars);
    }

    public static String toLowerCase2(String s) {
        String[] abc = new String[]{"А", "Б", "В", "Г", "Д", "Е", "Ж", "З", "И", "Й", "К", "Л", "М", "Н", "О", "П", "Р", "С", "Т", "У", "Ф", "Х", "Ц", "Ч", "Ш", "Щ", "Ъ", "Ы", "Ь", "Э", "Ю", "Я",
            "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"
        };
        String[] abc2 = new String[]{"а", "б", "в", "г", "д", "е", "ж", "з", "и", "й", "к", "л", "м", "н", "о", "п", "р", "с", "т", "у", "ф", "х", "ц", "ч", "ш", "щ", "ъ", "ы", "ь", "э", "ю", "я",
            "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"
        };
//StringBuffer sb=new StringBuffer();

        for (int i = 0; i < abc.length; i++) {
            s = TextUtils.replace(s, abc[i], abc2[i]);
        }


        return s;
    }

    public static String htmlentities_decode(String s) {
        String[] chars = {"&amp;", "&quot;", "&apos;", "&lt;", "&gt;", "&nbsp;"};
        String[] symbol = {"&", "\"", "'", "<", ">", " "};
        for (int i = 0; i < s.length(); i++) {
            s = TextUtils.replace(s, chars[i], symbol[i]);
        }
        return s;
    }

    public static String toUpperCase(String s) {
        String[] abc = new String[]{"А", "Б", "В", "Г", "Д", "Е", "Ж", "З", "И", "Й", "К", "Л", "М", "Н", "О", "П", "Р", "С", "Т", "У", "Ф", "Х", "Ц", "Ч", "Ш", "Щ", "Ъ", "Ы", "Ь", "Э", "Ю", "Я",
            "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"
        };
        String[] abc2 = new String[]{"а", "б", "в", "г", "д", "е", "ж", "з", "и", "й", "к", "л", "м", "н", "о", "п", "р", "с", "т", "у", "ф", "х", "ц", "ч", "ш", "щ", "ъ", "ы", "ь", "э", "ю", "я",
            "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"
        };
//StringBuffer sb=new StringBuffer();

        for (int i = 0; i < abc.length; i++) {
            s = TextUtils.replace(s, abc2[i], abc[i]);
        }


        return s;
    }

// Упрощенный алгоритм Бойера-Мура
    /**
     * * Возвращает индекс первого вхождения строки template в строку source,
     * или * -1, в случае если вхождение не найдено.
     *
     * * @param source * исходная строка, в которой ищется вхождение шаблона.
     * @param template * шаблон строки, которая ищется в строке source.
     * @return индекс первого вхождения строки template в строку source, или -1,
     * * в случае если вхождение не найдено.
     */
    public int indexOf(String source, String template) {
        int sourceLen = source.length();
        int templateLen = template.length();
        if (templateLen > sourceLen) {
            return -1;
        }
        Hashtable offsetTable = new Hashtable();

        for (int i = 0; i <= 255; i++) {
            offsetTable.put(new Character((char) i), new Integer(templateLen));
        }

        for (int i = 0; i < templateLen - 1; i++) {
            offsetTable.put(new Character(template.charAt(i)), new Integer(templateLen - i - 1));
        }
        int i = templateLen - 1;
        int j = i;
        int k = i;
        while (j >= 0 && i <= sourceLen - 1) {
            j = templateLen - 1;
            k = i;
            while (j >= 0 && source.charAt(k) == template.charAt(j)) {
                k--;
                j--;
            }
            i += ((Integer) (offsetTable.get(new Character(source.charAt(i))))).intValue();
        }
        if (k >= sourceLen - templateLen) {
            return -1;
        } else {
            return k + 1;
        }
    }

//простейший парсер html/wml/xml/fb2
    public static String html(String string_1) {

        StringBuffer sb = new StringBuffer("");
        int int_1 = string_1.length();
        int int_2 = 0;
        String string_2 = "";
        int int_3 = 0;
        for (; int_3 < int_1; int_3++) {
            char char_1 = string_1.charAt(int_3);
            if (char_1 == 60) {
                if (string_2.length() > 0) {
                    sb = sb.append(string_2 + " ");
                    string_2 = "";
                }
                int_2 = 1;
            } else if (char_1 == 62) {
                int_2 = 0;
            } else if (int_2 == 0 && char_1 > 31) {
                string_2 = string_2 + String.valueOf((char) char_1);
            }
        }
        if (string_2.length() > 0) {
            sb = sb.append(string_2 + " ");
        }
        return sb.toString();
    }

//чтение текста из файла (массива) с автоопределением кодировки (ютф8 и вин1251)
    public static String byteArrayToString(byte[] bytes, String encoding) {


        if (encoding.equals("win1251")) {
            char[] map = "\u0402\u0403\u201A\u0453\u201E\u2026\u2020\u2021\u20AC\u2030\u0409\u2039\u040A\u040C\u040B\u040F\u0452\u2018\u2019\u201C\u201D\u2022\u2013\u2014\uFFFD\u2122\u0459\u203A\u045A\u045C\u045B\u045F\u00A0\u040E\u045E\u0408\u00A4\u0490\u00A6\u00A7\u0401\u00A9\u0404\u00AB\u00AC\u00AD\u00AE\u0407\u00B0\u00B1\u0406\u0456\u0491\u00B5\u00B6\u00B7\u0451\u2116\u0454\u00BB\u0458\u0405\u0455\u0457\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F".toCharArray();
            char[] chars = new char[bytes.length];
            byte b;
            for (int i = 0; i < bytes.length; i++) {
                b = bytes[i];
                chars[i] = (b >= 0) ? (char) b : map[b + 128];
//            b=null;
            }
            map = null;
            bytes = null;

            String s = new String(chars);
            chars = null;
            return s;
        } else {
            try {
                return decodeUTF8(bytes, false);
            } catch (UTFDataFormatException udfe) {
//       System.out.println(udfe.toString());
            }
        }

        char[] map = "\u0402\u0403\u201A\u0453\u201E\u2026\u2020\u2021\u20AC\u2030\u0409\u2039\u040A\u040C\u040B\u040F\u0452\u2018\u2019\u201C\u201D\u2022\u2013\u2014\uFFFD\u2122\u0459\u203A\u045A\u045C\u045B\u045F\u00A0\u040E\u045E\u0408\u00A4\u0490\u00A6\u00A7\u0401\u00A9\u0404\u00AB\u00AC\u00AD\u00AE\u0407\u00B0\u00B1\u0406\u0456\u0491\u00B5\u00B6\u00B7\u0451\u2116\u0454\u00BB\u0458\u0405\u0455\u0457\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F".toCharArray();
        char[] chars = new char[bytes.length];
        byte b;
        for (int i = 0; i < bytes.length; i++) {
            b = bytes[i];
            chars[i] = (b >= 0) ? (char) b : map[b + 128];
//            b=null;
        }
        map = null;
        bytes = null;

        String s = new String(chars);
        chars = null;
        return s;

//        return null;

    }

    public static String UnicodeToString(InputStreamReader in) throws IOException {
        int BUFFER_SIZE = 300;
        char[] ac = new char[BUFFER_SIZE];

        int j = 0;
        StringBuffer buffer = new StringBuffer();
        int r = -1;
        while (j < ac.length && (r = in.read()) > 0 && r != 13) {
            ac[j++] = (char) r;
        }
        while (j > 0) {
            int copy = -1;
            for (int k = 0; k < j;) {
                if (ac[k] == '\\') {
                    if (k >= BUFFER_SIZE - 6) {
                        copy = k;
                        break;
                    }
                    if (ac[k + 1] == 'u') {
                        try {
                            int l = Integer.parseInt(new String(ac, k + 2, 4), 16);
                            k = +6;
                            buffer.append(new String(new char[]{(char) l}));
                        } catch (NumberFormatException ex) {
                        }
                    } else {
                        buffer.append(new String(ac, k, 1));
                        k++;
                    }
                } else {
                    buffer.append(new String(ac, k, 1));
                    k++;
                }
            }
            if (r == 13 || r < 0) {
                break;
            }
            if (copy != -1) {
                int limit = j;
                j = 0;
                for (int i = copy; i < BUFFER_SIZE && i < limit; i++) {
                    ac[j++] = ac[i];
                }
            } else {
                j = 0;
            }
            while (j < ac.length && (r = in.read()) > 0 && r != 13) {
                ac[j++] = (char) r;
            }
        }
        if (r == -1 && buffer.length() == 0) {

            ac = null;

            in.close();

            in = null;
            return null;
        } else {

            ac = null;

            in.close();

            in = null;
            return buffer.toString().trim();
        }
    }

    public static String convCp1251ToUnicode(final byte[] buf) {
        if (buf == null) {
            return null;
        }
        int count = buf.length;
        char[] chars = new char[count];
        for (int i = 0; i < count; i++) {
            byte b = buf[i];
            char ch;
            // украинские буквы
            if (b == -77) {
                ch = 0x456;
            } else if (b == -65) {
                ch = 0x457;
            } else if (b == -70) {
                ch = 0x454;
            } else if (b == -76) {
                ch = 0x491;
            } else if (b == -78) {
                ch = 0x406;
            } else if (b == -81) {
                ch = 0x407;
            } else if (b == -91) {
                ch = 0x490;
            } else if (b == -86) {
                ch = 0x404;
            } // остальные
            else if (b == -70) {
                ch = 0x401;
            } else if (b == -72) {
                ch = 0x451;
            } else if (b < 0) {
                ch = (char) (0x400 | ((b & 0x7f) - 0x30));
            } else {
                ch = (char) b;
            }
            chars[i] = ch;
        }
        return new String(chars);
    }

    public static String convCp1251ToUnicode(final String s) {
        if (s == null) {
            return null;
        }
        StringBuffer b = new StringBuffer(s.length());
        for (int i = 0; i < s.length(); i++) {
            char ch = s.charAt(i);

            // украинские буквы
            if (ch == 0xb3) {
                ch = 0x456;
            } else if (ch == 0xbf) {
                ch = 0x457;
            } else if (ch == 0xba) {
                ch = 0x454;
            } else if (ch == 0xb4) {
                ch = 0x491;
            } else if (ch == 0xb2) {
                ch = 0x406;
            } else if (ch == 0xaf) {
                ch = 0x407;
            } else if (ch == 0xa5) {
                ch = 0x490;
            } else if (ch == 0xaa) {
                ch = 0x404;
            } // остальные
            else if (ch > 0xbf && ch < 0x410 && ch != 0x401) {
                ch += 0x410 - 0xc0;
            } else if (ch == 0xa8) {
                ch = 0x401;
            } else if (ch == 0xb8) {
                ch = 0x451;
            }
            b.append(ch);
        }
        return b.toString();
    }

    public static String convUnicodeToCp1251(final String s) {
        if (s == null) {
            return null;
        }
        StringBuffer b = new StringBuffer(s.length());
        for (int i = 0; i < s.length(); i++) {
            char ch = s.charAt(i);
            // украинские буквы
            if (ch == 0x456) {
                ch = 0xb3;
            } else if (ch == 0x457) {
                ch = 0xbf;
            } else if (ch == 0x454) {
                ch = 0xba;
            } else if (ch == 0x491) {
                ch = 0xb4;
            } else if (ch == 0x406) {
                ch = 0xb2;
            } else if (ch == 0x407) {
                ch = 0xaf;
            } else if (ch == 0x490) {
                ch = 0xa5;
            } else if (ch == 0x404) {
                ch = 0xaa;
            } // остальные
            else if (ch == 0x401) {
                ch = 0xa8; //Ё
            } else if (ch == 0x451) {
                ch = 0xb8; //ё
            } else if (ch > 0x409) {
                ch += 0xc0 - 0x410;
            }
            b.append(ch);
        }
        return b.toString();
    }

    public static byte[] convUnicodeToCp1251Byte(final String s) {
        char ch[] = convUnicodeToCp1251(s).toCharArray();
        int count = ch.length;
        byte b[] = new byte[count];
        for (int i = 0; i < count; i++) {
            b[i] = (byte) ch[i];
        }
        return b;
    }
    final static String alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

    public static String toBase64(String source) {
        int len = source.length();
        char[] out = new char[((len + 2) / 3) * 4];
        for (int i = 0, index = 0; i < len; i += 3, index += 4) {
            boolean trip = false;
            boolean quad = false;

            int val = (0xFF & source.charAt(i)) << 8;
            if ((i + 1) < len) {
                val |= (0xFF & source.charAt(i + 1));
                trip = true;
            }
            val <<= 8;
            if ((i + 2) < len) {
                val |= (0xFF & source.charAt(i + 2));
                quad = true;
            }
            out[index + 3] = alphabet.charAt((quad ? (val & 0x3F) : 64));
            val >>= 6;
            out[index + 2] = alphabet.charAt((trip ? (val & 0x3F) : 64));
            val >>= 6;
            out[index + 1] = alphabet.charAt(val & 0x3F);
            val >>= 6;
            out[index] = alphabet.charAt(val & 0x3F);
        }
        return new String(out);
    }

    public static String toBase64(byte source[], int len) {
        if (len < 0) {
            len = source.length;
        }
        char[] out = new char[((len + 2) / 3) * 4];
        for (int i = 0, index = 0; i < len; i += 3, index += 4) {
            boolean trip = false;
            boolean quad = false;

            int val = (0xFF & source[i]) << 8;
            if ((i + 1) < len) {
                val |= (0xFF & source[i + 1]);
                trip = true;
            }
            val <<= 8;
            if ((i + 2) < len) {
                val |= (0xFF & source[i + 2]);
                quad = true;
            }
            out[index + 3] = alphabet.charAt((quad ? (val & 0x3F) : 64));
            val >>= 6;
            out[index + 2] = alphabet.charAt((trip ? (val & 0x3F) : 64));
            val >>= 6;
            out[index + 1] = alphabet.charAt(val & 0x3F);
            val >>= 6;
            out[index] = alphabet.charAt(val & 0x3F);
        }
        return new String(out);
    }

    public static StringBuffer toUTFSb(StringBuffer str) {
        int srcLen = str.length();
        StringBuffer outbuf = new StringBuffer(srcLen);
        for (int i = 0; i < srcLen; i++) {
            int c = (int) str.charAt(i);
            if ((c >= 1) && (c <= 0x7f)) {
                outbuf.append((char) c);
            }
            if (((c >= 0x80) && (c <= 0x7ff)) || (c == 0)) {
                outbuf.append((char) (0xc0 | (0x1f & (c >> 6))));
                outbuf.append((char) (0x80 | (0x3f & c)));
            }
            if ((c >= 0x800) && (c <= 0xffff)) {
                outbuf.append(((char) (0xe0 | (0x0f & (c >> 12)))));
                outbuf.append((char) (0x80 | (0x3f & (c >> 6))));
                outbuf.append(((char) (0x80 | (0x3f & c))));
            }
        }
        return outbuf;
    }

    public static byte[] fromBase64(String s) {
        return baosFromBase64(s).toByteArray();
    }

    public static String sFromBase64(String s) {
        return baosFromBase64(s).toString();
    }

    private static ByteArrayOutputStream baosFromBase64(String s) {
        int padding = 0;
        int ibuf = 1;
        ByteArrayOutputStream baos = new ByteArrayOutputStream(2048);
        for (int i = 0; i < s.length(); i++) {
            int nextChar = s.charAt(i);
            //if( nextChar == -1 )
            //    throw new EndOfXMLException();
            int base64 = -1;
            if (nextChar > 'A' - 1 && nextChar < 'Z' + 1) {
                base64 = nextChar - 'A';
            } else if (nextChar > 'a' - 1 && nextChar < 'z' + 1) {
                base64 = nextChar + 26 - 'a';
            } else if (nextChar > '0' - 1 && nextChar < '9' + 1) {
                base64 = nextChar + 52 - '0';
            } else if (nextChar == '+') {
                base64 = 62;
            } else if (nextChar == '/') {
                base64 = 63;
            } else if (nextChar == '=') {
                base64 = 0;
                padding++;
            } else if (nextChar == '<') {
                break;
            }
            if (base64 >= 0) {
                ibuf = (ibuf << 6) + base64;
            }
            if (ibuf >= 0x01000000) {
                baos.write((ibuf >> 16) & 0xff);                   //00xx0000 0,1,2 =
                if (padding < 2) {
                    baos.write((ibuf >> 8) & 0xff);     //0000xx00 0,1 =
                }
                if (padding == 0) {
                    baos.write(ibuf & 0xff);         //000000xx 0 =
                }
                //len+=3;
                ibuf = 1;
            }
        }
        try {
            baos.close();
        } catch (Exception ignored) {
        }
        return baos;
    }

    public static String unicodeToUTF(String src) {
        return toUTFSb(new StringBuffer(src)).toString();
    }

//сохранение строки в файл (массив байт) с кодировкой ютф8
    public static byte[] encodeUTF8(String text) {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        byte[] ret;

        for (int i = 0; i < text.length(); i++) {
            char c = text.charAt(i);
            if (c != '\u0000' && c < '\u0080') {
                baos.write(c);
            } else if (c == '\u0000' || (c >= '\u0080' && c < '\u0800')) {
                baos.write((byte) (0xc0 | (0x1f & (c >> 6))));
                baos.write((byte) (0x80 | (0x3f & c)));
            } else {
                baos.write((byte) (0xe0 | (0x0f & (c >> 12))));
                baos.write((byte) (0x80 | (0x3f & (c >> 6))));
                baos.write((byte) (0x80 | (0x3f & c)));
            }
        }
        ret = baos.toByteArray();

        return ret;
    }

    public static String decodeUTF8(byte[] data, boolean gracious) throws UTFDataFormatException {
        byte a, b, c;
        StringBuffer ret = new StringBuffer();

        for (int i = 0; i < data.length; i++) {
            try {
                a = data[i];
                if ((a & 0x80) == 0) {
                    ret.append((char) a);
                } else if ((a & 0xe0) == 0xc0) {
                    b = data[i + 1];
                    if ((b & 0xc0) == 0x80) {
                        ret.append((char) (((a & 0x1F) << 6) | (b & 0x3F)));
                        i++;
                    } else {
                        throw new UTFDataFormatException("Illegal 2-byte group");
                    }
                } else if ((a & 0xf0) == 0xe0) {
                    b = data[i + 1];
                    c = data[i + 2];
                    if (((b & 0xc0) == 0x80) && ((c & 0xc0) == 0x80)) {
                        ret.append((char) (((a & 0x0F) << 12) | ((b & 0x3F) << 6) | (c & 0x3F)));
                        i += 2;
                    } else {
                        throw new UTFDataFormatException("Illegal 3-byte group");
                    }
                } else if (((a & 0xf0) == 0xf0) || ((a & 0xc0) == 0x80)) {
                    throw new UTFDataFormatException("Illegal first byte of a group");
                }
            } catch (UTFDataFormatException udfe) {
                if (gracious) {
                    ret.append("?");
                } else {
                    throw udfe;
                }
            } catch (ArrayIndexOutOfBoundsException aioobe) {
                if (gracious) {
                    ret.append("?");
                } else {
                    throw new UTFDataFormatException("Unexpected EOF");
                }
            }
        }
        data = null;

        return ret.toString();
    }

//разбиение строки в массив подстрок с строчным делителем
    public static String[] splitString(String string_1, String string_2) {
        if (string_1 == null) {
            return null;
        }
        if (string_1.length() == 0 || string_2 == null || string_2.length() == 0) {
            return new String[]{string_1};
        }
        Vector vector_1 = new Vector();
        int int_1 = 0;
        int int_2 = string_1.indexOf(string_2, int_1);
        while (int_2 != -1) {
            vector_1.addElement(string_1.substring(int_1, int_2));
            int_1 = int_2 + string_2.length();
            int_2 = string_1.indexOf(string_2, int_1);
        }
        vector_1.addElement(string_1.substring(int_1));
        String[] strings_1 = new String[vector_1.size()];
        vector_1.copyInto(strings_1);
        //vector_1 = null;
        return strings_1;
    }

//удаление из строки подстроки с указаным началом и концом
    public static String stringDelete(String str, int startIndex, int endIndex) {
        if (endIndex < str.length()) {
            return str.substring(0, startIndex).concat(str.substring(endIndex));
        } else {
            return str.substring(0, str.length() - 1);
        }
    }

//удаление символа
    public static String stringDelete(String str, int index) {
        return stringDelete(str, index, index + 1);
    }

//вставка в строку подстроки с указанной позиции
    public static String stringInsert(String str, String ins, int index) {
        if (index > 0) {
            return str.substring(0, index) + ins + str.substring(index);
        } else {
            return ins + str;
        }
    }
//замена подстрокой части строки начиная с позиции

    public static String stringReplace(String str, String replace, int index) {
        return stringInsert(stringDelete(str, index, index + replace.length()), replace, index);
    }
//замена в строке s подстроки s1 вместо s2

    public static String replace(String s, String s1, String s2) {
        String out = " ";
        s = s + " ";
        int i = s.indexOf(s1);
        while (i > -1) {
            out += s.substring(0, i) + s2;
            s = s.substring(i + s1.length());
            i = s.indexOf(s1);
        }
        out += s;
        return out.substring(1, out.length() - 1);
    }

    public static String processMacros(String s) {
        return replace(s, "^n", "\n");
    }

//поиск в массиве строк имеющих в себе ключ
    public static String[] search(String[] array, String key) {
        Vector v = new Vector();
        String[] result;

        int bin = BinarySearch(array, key, true);

        if (bin != -1) {
            v.addElement(array[bin]);
            result = new String[v.size()];
            v.copyInto(result);
            v.removeAllElements();
            v = null;
            return result;
        } else {
            String temp;

            for (int i = 0; i < array.length; i++) {
                temp = array[i];

                if (temp.indexOf(key) != -1) {
                    v.addElement(temp);
                }
            }
            result = new String[v.size()];
            v.copyInto(result);
            v.removeAllElements();
            v = null;
            return result;

        }


//return null;


    }

//бинарный поиск строки в массиве.Необходимо отсортировать список,передав параметр true
    public static int BinarySearch(String[] array, String key, boolean notSorted) {

        return BinarySearch(array, 0, array.length, key, notSorted);
    }

    public static int BinarySearch(String[] array, int start, int end, String key, boolean notSorted) {
        if (start > end) {
            return -1;
        }
        if (end > array.length) {
            return -1;
        }

        if (notSorted) {
            array = quickSort(array, false, true, true);
        }

        int Median = (start + end) / 2;

        String temp = array[Median];


        switch (key.compareTo(temp)) {

            case -1:
                end = Median - 1;
                return BinarySearch(array, start, end, key, false);
//break;

            case 0:
                return Median;
//break;

            case 1:
                start = Median + 1;
                return BinarySearch(array, start, end, key, false);
//break;


        }
        return -1;
    }

    public static void swap(String[] arr, int i, int j) {
        String t = arr[i];
        arr[i] = arr[j];
        arr[j] = t;
    }

//для фм'ов.упорядочить список так чтобы папки были вверху, а файлы внизу списка
    public static String[] sortFiles(String[] as) {
        int length = as.length;
        String[] as1 = new String[length];

//Vector v=new Vector();
        int i = 0;
        for (int j = 0; j < length; j++) {
            if (as[j].indexOf("/") != -1) {
                as1[i] = as[j];
                i++;
            }
        }
        for (int k = 0; k < length; k++) {
            if (as[k].indexOf("/") == -1) {
                as1[i] = as[k];
                i++;
            }
        }
        return as1;
    }

    public static boolean compare(String x, String y, boolean ignoreCase) {
        return x(x, y, ignoreCase);
    }

    public static boolean x(String x, String y, boolean ignoreCase) {

        if (ignoreCase) {
            x = x.toLowerCase();
            y = y.toLowerCase();
        }


        if (x.compareTo(y) > 0) {
            return true;
        }



        return false;
    }

//по названию понятно.Возвращает массив "задом наперед"
    public static String[] reverse(String[] a) {
        String[] b = new String[a.length];
        int j = a.length;
        for (int i = 0; i < j; i++) {
            b[(j - 1) - i] = a[i];
        }
        return b;
    }

//"пузырьковая" сортировка
    public static String[] bubbleSort(String[] arr, boolean reverse, boolean ignoreCase, boolean ifFm) {
        for (int i = arr.length - 1; i >= 0; i--) {
            for (int j = 0; j < i; j++) {
                if (x(arr[j], arr[j + 1], ignoreCase)) {
                    swap(arr, j, j + 1);
                }
            }
        }

        if (ifFm) {
            arr = sortFiles(arr);
        }

        if (reverse) {
            return reverse(arr);
        }
        return arr;
    }

//сортировка Шелла
//"быстрая" сортировка
    public static String[] quickSort(String[] arr, boolean reverse, boolean ignoreCase, boolean ifFm) {

        array = (arr);

        ARRAY_LENGTH = array.length;

        quickSort(ignoreCase);


        if (ifFm) {
            array = sortFiles(array);
        }

        if (reverse) {
            return reverse(array);
        }
        return array;


    }

    public static void quickSort(boolean ignoreCase) {


        int startIndex = 0;
        int endIndex = ARRAY_LENGTH - 1;
        doSortS(startIndex, endIndex, ignoreCase);
    }

    private static void doSortS(int start, int end, boolean ignoreCase) {

        if (start >= end) {
            return;
        }

        int i = start, j = end;

        int cur = i - (i - j) / 2;

        while (i < j) {


            while (i < cur && (compare(array[cur], array[i], ignoreCase))) {
                i++;
            }



            while (j > cur && (compare(array[j], array[cur], ignoreCase))) {
                j--;
            }
            if (i < j) {
                String temp = array[i];
                array[i] = array[j];
                array[j] = temp;
                if (i == cur) {
                    cur = j;
                } else if (j == cur) {
                    cur = i;
                }
            }
        }
        doSortS(start, cur, ignoreCase);
        doSortS(cur + 1, end, ignoreCase);
    }

    /**
     * sorts string array in ascending order
     *
     * @param array
     * @return sorted array
     */
    public static String[] sort(String[] array) {
        for (int k = array.length >> 1; k > 0; k >>= 1) {
            for (int i = k; i < array.length; i++) {
                int j = i;
                String v = array[j];
                while (j >= k && ((array[j - k])).compareTo(v) > 0) {
                    array[j] = array[j - k];
                    j -= k;
                }
                array[j] = v;
            }
        }
        return array;
    }

    public static String substring(String src, int start, int end) {
        /*
         * if (start < 0) { return null; } if (end > src.length()) { return
         * null; } if (start > end) { return null; } char[] map =
         * src.toCharArray(); src=null; char[] dest = new char[end - start];
         *
         *
         * System.arraycopy(map, start, dest, 0, end); map = null;
         *
         * StringBuffer sb = new StringBuffer(); sb.append(dest);
         *
         * dest = null;
         *
         * return sb.toString();
         */
        return src.substring(start, end);
    }
}
