/**
 *
 * @author HoldFast
 */
package org.holdfast.shazam;

import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;
import org.holdfast.TextUtils;

public class Shazam {

    private static String getDeviceID() {
        try {
            String adress = "http://orbit.shazam.com/orbit/RequestConfig1?deviceId=unknown&service=cn%3DMotorolaIndia%2Ccn%3DConfig%2Ccn%3DMotoIdP%2Ccn%3Dservices&language=ru-RU&modelName=unknown&appName=MusicID&appVersion=1.8.14";
            HttpConnection http = (HttpConnection) Connector.open(adress);
            http.setRequestProperty("User-Agent", "\"SonyEricssonK790i/R8BF Profile/MIDP-2.0 Configuration/CLDC-1.1");
            http.setRequestProperty("Host", "orbit.shazam.com");
            http.setRequestMethod(HttpConnection.GET);
            InputStream is = http.openInputStream();

            ByteArrayOutputStream bytearrayoutputstream_1 = new ByteArrayOutputStream();
            int int_1 = 500;
            byte[] bytes_1 = new byte[int_1];
            int int_2;
            do {
                int_2 = is.read(bytes_1, 0, int_1);
                if (int_2 != -1) {
                    bytearrayoutputstream_1.write(bytes_1, 0, int_2);
                }
            } while (int_2 != -1);
            http.close();
            is.close();
            bytearrayoutputstream_1.flush();
            bytearrayoutputstream_1.close();
            String s = TextUtils.decodeUTF8(bytearrayoutputstream_1.toByteArray(), true);
            String id = s.substring(s.indexOf("<uid>") + 5, s.indexOf("</uid>"));
            return id;
        } catch (Exception e) {
            return "";
        }
    }

    private static String getRequestID(byte[] audio, String deviceID) {
        try {

            ByteArrayOutputStream post;
            (post = new ByteArrayOutputStream()).write(("--" + Shazam.f + "\r\n").getBytes());
            post.write("Content-Disposition: form-data; name=\"service\"\r\n".getBytes());
            post.write("\r\n".getBytes());
            post.write("cn=xxxx,cn=MotorolaIndia,cn=unknown,cn=MotoIdP,cn=services\r\n".getBytes());
            post.write(("--" + Shazam.f + "\r\n").getBytes());
            post.write("Content-Disposition: form-data; name=\"language\"\r\n".getBytes());
            post.write("\r\n".getBytes());
            post.write("ru\r\n".getBytes());
            post.write(("--" + Shazam.f + "\r\n").getBytes());
            post.write("Content-Disposition: form-data; name=\"deviceId\"\r\n".getBytes());
            post.write("\r\n".getBytes());
            post.write((deviceID + "\r\n").getBytes());
            post.write(("--" + Shazam.f + "\r\n").getBytes());
            post.write("Content-Disposition: form-data; name=\"tagDate\"\r\n".getBytes());
            post.write("\r\n".getBytes());
            post.write("2013-10-02T18:06:11\r\n".getBytes());
            post.write(("--" + Shazam.f + "\r\n").getBytes());
            post.write("Content-Disposition: form-data; name=\"sample\"; filename=\"rome.amr\"\r\n".getBytes());
            post.write("Content-Type: application/octet-stream\r\n".getBytes());
            post.write("\r\n".getBytes());
            post.write(audio);
            post.write("\r\n".getBytes());
            post.write(("--" + Shazam.f + "\r\n").getBytes());
            post.write("Content-Disposition: form-data; name=\"sampleBytes\"\r\n".getBytes());
            post.write("\r\n".getBytes());
            post.write((audio.length + "\r\n").getBytes());
            post.write(("--" + Shazam.f + "--\r\n").getBytes());
            post.flush();
            post.close();
            ByteArrayOutputStream var3 = new ByteArrayOutputStream();
            HttpConnection http;
            (http = (HttpConnection) Connector.open("http://orbit.shazam.com/orbit/DoRecognition1")).setRequestProperty("User-Agent", "ShazamROME/2.0");
            http.setRequestProperty("Content-Language", "ru");
            http.setRequestProperty("Connection", "close");
            http.setRequestProperty("Content-Type", "multipart/form-data; boundary=" + Shazam.f);
            http.setRequestProperty("Host", "orbit.shazam.com");
            http.setRequestMethod("POST");
            http.openOutputStream().write(post.toByteArray());

            InputStream is = http.openInputStream();

            ByteArrayOutputStream bytearrayoutputstream_1 = new ByteArrayOutputStream();
            int int_1 = 500;
            byte[] bytes_1 = new byte[int_1];
            int int_2;
            do {
                int_2 = is.read(bytes_1, 0, int_1);
                if (int_2 != -1) {
                    bytearrayoutputstream_1.write(bytes_1, 0, int_2);
                }
            } while (int_2 != -1);
            http.close();
            is.close();
            bytearrayoutputstream_1.flush();
            bytearrayoutputstream_1.close();
            String s = TextUtils.decodeUTF8(bytearrayoutputstream_1.toByteArray(), true);
            return s.substring(s.indexOf("<requestId id=\"") + 15, s.indexOf("\"/>"));
            // return s;
        } catch (Exception ex) {
            return "";
        }
    }

    private static String[] getResponse(String deviceID, String requestID) {
        String re[] = new String[2];
        String url = "http://orbit.shazam.com/orbit/RequestResults1?language=ru&service=cn=xxxx,cn=MotorolaIndia,cn=unknown,cn=MotoIdP,cn=services&deviceId=" + deviceID + "&requestId=" + requestID;
        try {
            HttpConnection http = (HttpConnection) Connector.open(url);
            http.setRequestProperty("User-Agent", "\"SonyEricssonK790i/R8BF Profile/MIDP-2.0 Configuration/CLDC-1.1");
            http.setRequestProperty("Host", "orbit.shazam.com");
            http.setRequestMethod(HttpConnection.GET);
            InputStream is = http.openInputStream();

            ByteArrayOutputStream bytearrayoutputstream_1 = new ByteArrayOutputStream();
            int int_1 = 500;
            byte[] bytes_1 = new byte[int_1];
            int int_2;
            do {
                int_2 = is.read(bytes_1, 0, int_1);
                if (int_2 != -1) {
                    bytearrayoutputstream_1.write(bytes_1, 0, int_2);
                }
            } while (int_2 != -1);
            http.close();
            is.close();
            bytearrayoutputstream_1.flush();
            bytearrayoutputstream_1.close();
            String s = TextUtils.htmlentities_decode(TextUtils.decodeUTF8(bytearrayoutputstream_1.toByteArray(), true));

            re[1] = s.substring(s.indexOf("<ttitle>") + 8, s.indexOf("</ttitle>"));
            re[0] = (s.substring(s.indexOf("<tartist id=\"") + 13, s.indexOf("</tartist>")));
            re[0] = TextUtils.substring(re[0], re[0].indexOf("\">") + 2, re[0].length());
            return re;
        } catch (Exception e) {
            return null;
        }
    }

    public static String[] getArtist(byte[] audio) {
        String requestID;
        String deviceID = getDeviceID();
        String[] res;
        if (!"".equals(deviceID)) {
            requestID = getRequestID(audio, deviceID);
            if (!"".equals(requestID)) {
                res = getResponse(deviceID, requestID);
                if (res != null) {
                    return res;
                } else {
                    return null;
                }
            } else {
                return null;
            }
        } else {
            return null;
        }
    }
    private static String f = "AVfv12SkReQeY2Bh";
}
